unit Foundation;

{$mode objfpc}{$H+}
{$linkframework Foundation}

interface

uses
  objcrtl;

type
  NSString = id;
  NSAutoreleasePool = id;

function NSStr(const Text: WideString): NSString;

implementation

uses
  objcrtlutils;

function NSStr(const Text: WideString): NSString;
type
  TSendProc = function (trg: id; _cmd:SEL; chars: PWideChar; len: Integer): id; cdecl;
begin
  if Text = '' then
    Result := AllocAndInit('NSString')
  else begin
    Result := alloc('NSString');
    if not Assigned(Result) then Exit;
    Result := TSendProc(objc_msgSend)(Result, selector('initWithCharacters:length:'), @Text[1], length(Text));
  end;
end;

end.

